
#include "ntm.h"

#define YOUR_IMPLEMENTATION     (1)
#define UNUSED_VARIABLE(N)      do { (void)(N); } while (0)

typedef struct {
    ntmshell_t ntmshell;
    int my_example_number;
    char my_example_text[16];
} example_work_t;

static int func_read(char *buf, int cnt, void *extobj)
{
#if (YOUR_IMPLEMENTATION)
    example_work_t *w = (example_work_t *)extobj;
    UNUSED_VARIABLE(w);
    UNUSED_VARIABLE(buf);
    UNUSED_VARIABLE(cnt);
#else
    /*
     * @todo Read characters to the buf.
     * @note This is a blocking interface.
     */
#endif
    return cnt;
}

static int func_write(const char *buf, int cnt, void *extobj)
{
#if (YOUR_IMPLEMENTATION)
    example_work_t *w = (example_work_t *)extobj;
    UNUSED_VARIABLE(w);
    UNUSED_VARIABLE(buf);
    UNUSED_VARIABLE(cnt);
#else
    /*
     * @todo Write characters from the buf.
     * @note This is a blocking interface.
     */
#endif
    return cnt;
}

int main(void)
{
    example_work_t w;
    ntm_execute(&(w.ntmshell), func_read, func_write, (void *)&w);
    return 0;
}

